Subject: bug#56334: Should asdf-build-system/sbcl use load-system instead of compile-system?

From: Guillaume Le Vaillant <[email-masked]>
Date: Fri, 01 Jul 2022 16:40:44 +0000

Pierre Neidhardt <[email-masked]> skribis:

> Hi Guillaume,
>
> I gave it a go and your suggestion indeed cuts it for cleavir and
> cl-gamepad.
>
> It did not fix it for the tests though.
>
> I did some more testing, and this is what I found out on one of the
> failing systems (cl-reexport): from a --pure sbcl repl, if I load the
> .asd files manually then run test-system, I can reproduce the issue.
>
> However, if I run
>
>  (asdf:initialize-source-registry
>     `(:source-registry (:tree ,(uiop:getcwd))
>                        :inherit-configuration))
>   (asdf:test-system :cl-reexport)
>
> then it works!
>
> In other words, I believe that `asdf:load-asd' is yet another under-used
> ASDF function, and we should probably go with the officially recommended
> way, namely adding the source folder to the ASDF registry.
>
> Thoughts?
>
> I'll try it out then send a patch.
>
> Cheers!

I think using the 'initialize-source-registry' technique instead of
'load-asd' would also make the '#:asd-files' and '#:test-asd-file'
arguments of the build system unnecessary, so they could be removed.